# the value from locals will be removed, which is desired
# pylint: disable=import-outside-toplevel
# pylint: disable=missing-function-docstring,missing-class-docstring
# pylint: disable=missing-module-docstring
# pylint: disable=too-many-lines,too-many-locals

from unittest import main, TestCase
from unittest.mock import patch, MagicMock


class Common(TestCase):
    def test_loggging_decorator_nolog(self):
        from butch.commands import what_func, LOG_STR
        from butch.context import Context
        from typing import NamedTuple

        dummy_value = 123
        func_name = "dummy"

        self.assertNotIn(func_name, locals())

        @what_func
        def dummy():
            return dummy_value

        self.assertIn(func_name, locals())

        ctx = Context()
        mocked = MagicMock()
        ctx.log.debug = mocked

        self.assertEqual(dummy(), dummy_value)
        mocked.assert_not_called()

    def test_loggging_decorator(self):
        from butch.commands import what_func, LOG_STR
        from butch.context import Context
        from typing import NamedTuple

        dummy_value = 123
        func_name = "dummy"

        self.assertNotIn(func_name, locals())

        @what_func
        def dummy(**__):
            return dummy_value

        self.assertIn(func_name, locals())

        ctx = Context()
        mocked = MagicMock()
        ctx.log.debug = mocked

        self.assertEqual(dummy(ctx=ctx), dummy_value)
        mocked.assert_called_once_with(LOG_STR, func_name, None, ctx)
